#ifndef ECOFFLINEABIMPORTER_INCLUDED
#define ECOFFLINEABIMPORTER_INCLUDED

#include "zcdefs.h"
#include <IECImportAddressbookChanges.h>
#include <IECServiceAdmin.h>

class ECLogger;

class OfflineABImporter _final : public IECImportAddressbookChanges {
public:
	OfflineABImporter(IECServiceAdmin *lpDstServiceAdmin, IECServiceAdmin *lpSrcServiceAdmin);
	~OfflineABImporter();
	
	virtual ULONG __stdcall AddRef(void) _override;
	virtual ULONG __stdcall Release(void) _override;
	virtual HRESULT __stdcall QueryInterface(REFIID iid, void **lpvoid) _override;

	virtual HRESULT __stdcall GetLastError(HRESULT hr, ULONG ulFlags, LPMAPIERROR *lppMAPIError) _override;
	virtual HRESULT __stdcall Config(LPSTREAM lpState, ULONG ulFlags) _override;
	virtual HRESULT __stdcall UpdateState(LPSTREAM lpState) _override;
			
	virtual HRESULT __stdcall ImportABChange(ULONG ulObjType, ULONG cbObjId, LPENTRYID lpObjId) _override;
	virtual HRESULT __stdcall ImportABDeletion(ULONG ulType, ULONG cbObjId, LPENTRYID lpObjId) _override;

private:
	IECServiceAdmin *m_lpSrcServiceAdmin;
	IECServiceAdmin *m_lpDstServiceAdmin;
	ECLogger		*m_lpLogger;
};

#endif // ndef 
