#ifndef __STATSCLIENT_H__
#define __STATSCLIENT_H__

#include "zcdefs.h"
#include <map>
#include <string>
#include <ctime>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/un.h>

#include "ECLogger.h"

class StatsClient _final {
private:
	int fd;
	struct sockaddr_un addr;
	int addr_len;
	ECLogger *const logger;

	pthread_t countsSubmitThread;
public:
	volatile bool terminate; // older compilers don't do atomic_bool
	pthread_mutex_t mapsLock;
	std::map<std::string, double> countsMapDouble;
	std::map<std::string, int64_t> countsMapInt64;

public:
	StatsClient(const std::string & collectorSocket, ECLogger *const logger);
	~StatsClient();

	inline ECLogger *const getLogger() { return logger; }

	void countInc(const std::string & key, const std::string & key_sub);
	void countAdd(const std::string & key, const std::string & key_sub, const double n);
	void countAdd(const std::string & key, const std::string & key_sub, const int64_t n);

	void submit(const std::string & key, const time_t ts, const double value);
	void submit(const std::string & key, const time_t ts, const int64_t value);
};

#endif
